Index: /utils/readme.html
===================================================================
--- /utils/readme.html	(revision 10633)
+++ /utils/readme.html	(revision 10633)
@@ -0,0 +1,166 @@
+<h3>About NEMO</h3>
+
+<a href="https://nemo-ocean.eu">NEMO</a> standing for <strong>Nucleus for European Modelling of the Ocean</strong> 
+is a state-of-the-art modelling framework for research activities and forecasting services in 
+ocean and climate sciences, developed in a sustainable way by a European consortium.
+
+<h4>Overview</h4>
+
+<p>
+The NEMO ocean model has 3 major components:
+</p>
+
+<ul style="list-style-type: disclosure-closed;">
+ 	<li>
+     <span style="color: blue;">NEMO-OCE</span> 
+     models the ocean {thermo}dynamics and solves the primitive equations
+   </li>
+ 	<li>
+     <span style="color: grey;">NEMO-ICE (SI<sup>3</sup>: Sea-Ice Integrated Initiative)</span> 
+     models sea-ice {thermo}dynamics, brine inclusions and subgrid-scale thickness variations
+   </li>
+ 	<li>
+     <span style="color: green;">NEMO-TOP (Tracers in the Ocean Paradigm)</span> 
+     models the {on,off}line oceanic tracers transport and biogeochemical processes (using PISCES)
+   </li>
+</ul>
+
+<p>
+  These physical core engines are described in their respective 
+  <a href="https://nemo-ocean.eu/documentation">reference manuals</a> 
+  that must be cited for any work related to their use.
+</p>
+
+<h4>Additional capabilities</h4>
+
+<ul style="list-style-type: square; padding-left: 1.5em;">
+ 	<li>Create 
+     <a href="https://nemo-ocean.eu/framework/components/interfaces/#Mesh_refinement_AGRIF">embedded zooms</a> 
+     seamlessly thanks to 2-way nesting package <a href="https://agrif.imag.fr">AGRIF</a>
+   </li>
+ 	<li>Input-Output through effective 
+     <a href="https://forge.ipsl.jussieu.fr/ioserver">XIOS</a> 
+     software
+   </li>
+ 	<li>Coupling interface to other Earth system components based on 
+     <a href="https://portal.enes.org/oasis">OASIS</a>
+   </li>
+ 	<li>Opportunity to integrate an external biogeochemistry model</li>
+ 	<li>Versatile 
+     <a href="https://nemo-ocean.eu/framework/components/interfaces/#Interfaces_with_observations">data interface</a>
+   </li>
+ 	<li>Set of 
+     <a href="https://nemo-ocean.eu/framework/components/interfaces/">utilities</a> 
+     is also provided to {pre,post}process your data
+   </li>
+</ul>
+
+<h4>Reference Configurations and Test Cases</h4>
+
+Several <a href="https://nemo-ocean.eu/framework/components/configurations">built-in configurations</a> are provided to evaluate the skills and performances of the model. 
+They can be used as as first easy set-up and as template for setting up a new configuration.<br>
+<a href="https://github.com/NEMO-ocean/NEMO-examples">Idealized test cases</a> addressing specific physical processes are also available for download.
+
+<h4>Project literature</h4>
+
+<table class="table" style="width: unset; margin:auto">
+  <thead><tr><th>Component</th><th>Reference Manual</th><th>User Guide</th></tr></thead>
+  <tbody>
+    <tr>
+      <td>
+        <span style="color: blue;">NEMO-OCE</span>
+      </td>
+      <td>
+        <a href="https://doi.org/10.5281/zenodo.1464816">
+          <img style="vertical-align: text-bottom;" 
+               src="https://zenodo.org/badge/DOI/10.5281/zenodo.1464816.svg" alt="NEMO manual">
+        </a>
+      </td>
+      <td>
+        <img style="vertical-align: text-bottom;" 
+             src="https://zenodo.org/badge/DOI/10.5281/zenodo.1475325.svg" alt="NEMO user guide">
+      </td>
+    </tr>
+    <tr>
+      <td>
+        <span style="color: grey;">NEMO-ICE</span></td>
+      <td>
+        <img style="vertical-align: text-bottom;"
+             src="https://zenodo.org/badge/DOI/10.5281/zenodo.1471689.svg" alt="SI3 manual">
+      </td>
+      <td></td>
+    </tr>
+    <tr>
+      <td>
+        <span style="color: green;">NEMO-TOP</span>
+      </td>
+      <td>
+        <img style="vertical-align: text-bottom;" 
+             src="https://zenodo.org/badge/DOI/10.5281/zenodo.1471700.svg" alt="TOP manual">
+      </td>
+      <td></td>
+    </tr>
+  </tbody>
+</table>
+
+<p>
+Since 2014 the project has a <a href="https://www.geosci-model-dev.net/special_issue40.html">Special Issue</a> in 
+the open-access journal Geoscientific Model Development (GMD) from the European Geosciences Union (EGU).
+The main scope is to collect relevant manuscripts covering various topics and 
+to provide a single portal to assess the model potential and evolution.<br>
+Used by a wide audience, 
+numerous <a href="https://nemo-ocean.eu/projects">associated projects</a> have been carried out and 
+<a href="https://nemo-ocean.eu/bibliography/publications">various publications</a> are available.
+</p>
+
+<h4>Consortium bodies</h4>
+
+<p>
+The <a href="https://nemo-ocean.eu/category/institutes">NEMO Consortium</a> pulling together 5 European institutes 
+plans <a href="https://nemo-ocean.eu/consortium/governance">the sustainable development</a> in order to 
+keep a reliable evolving framework <a href="https://nemo-ocean.eu/consortium/history">since 2008</a>.
+</p>
+
+<div style="text-align: center;">
+  <ul style="list-style-type: none; padding: 0 0;">
+    <li style="display: inline-block; width: 100px;">
+      <a href="https://www.cmcc.it" target="_blank" rel="noopener noreferrer">
+        <img style="height: 50px;" 
+             src="https://nemo-ocean.eu/wp-content/uploads/CMCC.png"       alt="CMCC logo">
+      </a>
+    </li>
+    <li style="display: inline-block; width: 100px;">
+      <a href="https://www.cnrs.fr" target="_blank" rel="noopener noreferrer">
+        <img style="height: 50px;" 
+             src="https://nemo-ocean.eu/wp-content/uploads/CNRS.gif"       alt="CNRS logo">
+      </a>
+    </li>
+    <li style="display: inline-block; width: 100px;">
+      <a href="https://www.mercator-ocean.fr" target="_blank" rel="noopener noreferrer">
+        <img style="height: 50px;" 
+             src="https://nemo-ocean.eu/wp-content/uploads/MOI.png"        alt="MOI logo">
+      </a>
+    </li>
+    <li style="display: inline-block; width: 100px;">
+      <a href="https://www.metoffice.gov.uk" target="_blank" rel="noopener noreferrer">
+        <img style="height: 50px;" 
+           src="https://nemo-ocean.eu/wp-content/uploads/Met_Office.png" alt="Met Office logo">
+      </a>
+    </li>
+    <li style="display: inline-block; width: 100px;">
+      <a href="https://nerc.ukri.org" target="_blank" rel="noopener noreferrer">
+        <img style="height: 50px;" 
+             src="https://nemo-ocean.eu/wp-content/uploads/NERC.gif"       alt="NERC logo">
+      </a>
+    </li>
+  </ul>
+</div>
+
+<p>
+It defines the <a href="https://doi.org/10.5281/zenodo.1471663">multi-year development strategy</a> 
+that is implemented by the <a href="https://nemo-ocean.eu/consortium/team">System Team</a> on a yearly basis 
+in order to regularly release a new version.<br>
+When the need arises, 
+<a href="https://forge.ipsl.jussieu.fr/nemo/wiki/WorkingGroups">working groups</a> are created or resumed 
+to gather the community expertise for advising on the development activities.
+</p>