Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-IBM_EKMAN_INGV
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-IBM_EKMAN_INGV	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-IBM_EKMAN_INGV	(revision 10698)
@@ -82,5 +82,11 @@
   fi
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
 
 # END_BODY
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-PW6_CALYPSO
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-PW6_CALYPSO	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-PW6_CALYPSO	(revision 10698)
@@ -74,5 +74,11 @@
   fi
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
 
 # END_BODY
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-PW7_METO
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-PW7_METO	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-PW7_METO	(revision 10698)
@@ -84,5 +84,11 @@
 
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
 
 # END_BODY
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-PW7_MONSOON
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-PW7_MONSOON	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-PW7_MONSOON	(revision 10698)
@@ -83,5 +83,11 @@
 
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
 
 # END_BODY
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-X64_ADA
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-X64_ADA	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-X64_ADA	(revision 10698)
@@ -76,5 +76,11 @@
 
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
 
 # END_BODY
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-X64_IRENE
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-X64_IRENE	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-X64_IRENE	(revision 10698)
@@ -66,5 +66,11 @@
 
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
 
 # END_BODY
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-X64_IRENE_DEBUG
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-X64_IRENE_DEBUG	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-X64_IRENE_DEBUG	(revision 10698)
@@ -66,5 +66,11 @@
 
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
 
 # END_BODY
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-X64_MOBILIS
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-X64_MOBILIS	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-X64_MOBILIS	(revision 10698)
@@ -88,5 +88,12 @@
   fi
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
+
 # END_BODY
 # Don't remove neither change the previous line
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-XC40_METO
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-XC40_METO	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-XC40_METO	(revision 10698)
@@ -84,5 +84,12 @@
 
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
+
 # END_BODY
 # Don't remove neither change the previous line
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-XC_ARCHER_INTEL
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-XC_ARCHER_INTEL	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-XC_ARCHER_INTEL	(revision 10698)
@@ -90,5 +90,12 @@
   fi
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
+
 # END_BODY
 # Don't remove neither change the previous line
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-ifort_athena
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-ifort_athena	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-ifort_athena	(revision 10698)
@@ -74,5 +74,11 @@
   fi
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
 
 # END_BODY
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-ifort_athena_xios
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-ifort_athena_xios	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-ifort_athena_xios	(revision 10698)
@@ -100,5 +100,11 @@
   fi
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
 
 # END_BODY
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-macport_osx
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-macport_osx	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-macport_osx	(revision 10698)
@@ -75,5 +75,11 @@
 
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
 
 # END_BODY
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-macport_osx_debug
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-macport_osx_debug	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-macport_osx_debug	(revision 10698)
@@ -75,5 +75,11 @@
 
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
 
 # END_BODY
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-openmpi_KARA_MERCATOR_XIOS
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-openmpi_KARA_MERCATOR_XIOS	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-openmpi_KARA_MERCATOR_XIOS	(revision 10698)
@@ -67,5 +67,11 @@
 
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
 
 # END_BODY
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-openmpi_NAVITI_MERCATOR
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-openmpi_NAVITI_MERCATOR	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/batch-openmpi_NAVITI_MERCATOR	(revision 10698)
@@ -67,5 +67,11 @@
 
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
 
 # END_BODY
Index: NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/sette_batch_template
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/sette_batch_template	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/BATCH_TEMPLATE/sette_batch_template	(revision 10698)
@@ -75,5 +75,11 @@
 
 #
-  post_test_tidyup
+#
+# run post processing of sette only is run normally or expected error
+  NEMOEXIT=$?
+  case $NEMOEXIT in
+      0|123456|999) echo " NEMO finished with exit code $NEMOEXIT " ; post_test_tidyup ;;
+      *) echo " NEMO abort on an unexpected error (segmentation fault or whatever) $NEMOEXIT "
+  esac
 
 # END_BODY
Index: NEMO/branches/2019/fix_sette_ticket2239/all_functions.sh
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/all_functions.sh	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/all_functions.sh	(revision 10698)
@@ -90,4 +90,32 @@
 usage=" Usage : set_namelist input_namelist variable_name value"
 usage=" if value is a string ths is neede syntax : ./set_namelist namelist_name var_name \"new_value\" "
+
+# define validation dir
+set_valid_dir () {
+    LANG=en_US
+    REVISION_NB=`LC_MESSAGES=${LANG} svn info ${SETTE_DIR}/.. | grep "Last Changed Rev" | awk '{print $NF}'`
+    if [ ${#REVISION_NB} -eq 0 ]
+    then
+        echo "some problems with svn info command"
+        echo "some problems with svn info command" >> ${SETTE_DIR}/output.sette
+        REVISION_NB=`date +%Y%m%d`
+        echo "put in ${REVISION_NB} date"
+        echo "put in ${REVISION_NB} date" >> ${SETTE_DIR}/output.sette
+    else
+    echo "value of revision number of NEMOGCM: ${REVISION_NB}"
+    fi
+    NEMO_VALID=${NEMO_VALIDATION_DIR}/W${NEW_CONF}/${CMP_NAM}/${REVISION_NB}/${TEST_NAME}
+}
+
+# clean valid dir (move old ocean_output/run.stat and tracer to avoid checking them in case something wrong happen.
+clean_valid_dir () {
+   set_valid_dir
+   echo "validation directory is : $NEMO_VALID"
+   if [ -d $NEMO_VALID ] ; then
+      [ -f ${NEMO_VALID}/ocean.output ] && mv ${NEMO_VALID}/ocean.output ${NEMO_VALID}/ocean.output_old
+      [ -f ${NEMO_VALID}/run.stat ]     && mv ${NEMO_VALID}/run.stat     ${NEMO_VALID}/run.stat_old
+      [ -f ${NEMO_VALID}/tracer.stat ]  && mv ${NEMO_VALID}/tracer.stat  ${NEMO_VALID}/tracer.stat_old
+   fi
+}
 
 # function to set namelists parameters
@@ -179,5 +207,5 @@
         then
         grep "E R R O R" ${EXE_DIR}/ocean.output && echo "Some ERRORS at execution time, see ${EXE_DIR}/ocean.output"
-        exit 2
+        # exit 2 Error now catch in the report 
     fi
 
@@ -186,5 +214,5 @@
         echo "file time.step does not exist"   >> ${SETTE_DIR}/output.sette
         echo "some problems during execution of model"  >> ${SETTE_DIR}/output.sette 
-        exit 1
+        # exit 1 Error now catch in the report
     else
         echo "file time.step exists"  >> ${SETTE_DIR}/output.sette
@@ -195,20 +223,8 @@
 
 ################################################################
+#
 # Creation of NEMO_VALIDATION tree
-    LANG=en_US 
-    REVISION_NB=`LC_MESSAGES=${LANG} svn info ${SETTE_DIR}/.. | grep "Last Changed Rev" | awk '{print $NF}'`
-    if [ ${#REVISION_NB} -eq 0 ]
-    then
-    	echo "some problems with svn info command"
-    	echo "some problems with svn info command" >> ${SETTE_DIR}/output.sette
-    	REVISION_NB=`date +%Y%m%d`
-    	echo "put in ${REVISION_NB} date"
-    	echo "put in ${REVISION_NB} date" >> ${SETTE_DIR}/output.sette
-    else
-    echo "value of revision number of NEMOGCM: ${REVISION_NB}"
-    fi
-    cd ${NEMO_VALIDATION_DIR}
-    `mkdir -p ${NEMO_VALIDATION_DIR}/W${NEW_CONF}/${CMP_NAM}/${REVISION_NB}/${TEST_NAME}`
-    NEMO_VALID=${NEMO_VALIDATION_DIR}/W${NEW_CONF}/${CMP_NAM}/${REVISION_NB}/${TEST_NAME}
+    set_valid_dir
+    mkdir -p ${NEMO_VALID}
     if [ -d ${NEMO_VALID} ] ; then
 	echo "created ${NEMO_VALID} directory"   >> ${SETTE_DIR}/output.sette
@@ -218,5 +234,6 @@
 	exit 1
     fi
-    # Save output & debug files in NEMO_VALIDATION tree
+#
+# Save output & debug files in NEMO_VALIDATION tree
     echo "saving ocean & ice output, run.stat, tracer.stat files ...." >> ${SETTE_DIR}/output.sette
     echo "            " >> ${SETTE_DIR}/output.sette
Index: NEMO/branches/2019/fix_sette_ticket2239/param.cfg
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/param.cfg	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/param.cfg	(revision 10698)
@@ -2,11 +2,11 @@
 #
 # Compiler among those in NEMOGCM/ARCH
-COMPILER=X64_ADA
+COMPILER=XC40_METO_perso
 #
 # BATCH command
-BATCH_CMD=llsubmit
+BATCH_CMD=qsub
 #
 #- FORCING files storing
-FORCING_DIR=$WORKDIR/FORCING
+FORCING_DIR=/projects/jomp/pmathiot/SETTE_FORCING/v4.0
 #
 #- INPUT files storing
@@ -14,10 +14,10 @@
 #
 #- VALIDATION files storing
-NEMO_VALIDATION_DIR=$WORKDIR/NEMO_VALIDATION
+NEMO_VALIDATION_DIR=/projects/jomp/pmathiot/NEMO/NEMO_dev/NEMO/trunk/sette_ticket2239/NEMO_VALIDATION
 #
 # REFERENCE run.stat tracer.stat you want to compare with
 # (if no change to the default, no check on result change will be done)
-NEMO_VALIDATION_REF=/path/to/reference/sette/results
-NEMO_REV_REF=0000
+NEMO_VALIDATION_REF=/projects/jomp/pmathiot/NEMO/NEMO_dev/NEMO/trunk/sette_ticket2239/NEMO_VALIDATION
+NEMO_REV_REF=10691
 #
 # CMD for svn (some people use git svn) 
Index: NEMO/branches/2019/fix_sette_ticket2239/prepare_exe_dir.sh
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/prepare_exe_dir.sh	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/prepare_exe_dir.sh	(revision 10698)
@@ -68,4 +68,6 @@
 mkdir -p ${NEW_CONF}/${TEST_NAME}
 
+# PREPARE EXEC_DIR
+#==================
 export EXE_DIR=${CONFIG_DIR}/${NEW_CONF}/${TEST_NAME}
 
Index: NEMO/branches/2019/fix_sette_ticket2239/sette_cfg-ref.sh
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/sette_cfg-ref.sh	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/sette_cfg-ref.sh	(revision 10698)
@@ -66,4 +66,7 @@
 #                       in sette.sh. (each test in executed in its own directory)
 #
+#  clean_valid_dir    : rename ocean.output/run.stat and tracer.stat to avoid checking them in the report 
+#                       ( not doing it could lead to false positive )
+#
 #  prepare_job.sh     : to generate the script run_job.sh
 #
@@ -164,4 +167,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=8
@@ -190,4 +194,5 @@
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"GYREPIS_SHORT\"
@@ -231,4 +236,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=8
@@ -258,4 +264,5 @@
     export TEST_NAME="REPRO_4_2"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=8
@@ -296,4 +303,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -348,4 +356,5 @@
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"O2L3P_SHORT\"
@@ -421,4 +430,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -472,4 +482,5 @@
     export TEST_NAME="REPRO_8_4"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -533,4 +544,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -573,4 +585,5 @@
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"OFFP_SHORT\"
@@ -623,4 +636,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -664,4 +678,5 @@
     export TEST_NAME="REPRO_8_4"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -715,4 +730,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -739,4 +755,5 @@
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"AMM12_SHORT\"
@@ -774,4 +791,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -799,4 +817,5 @@
     export TEST_NAME="REPRO_4_8"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     if [ -f ${JOB_FILE} ] ; then \rm ${JOB_FILE} ; fi
@@ -834,4 +853,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -859,4 +879,5 @@
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"SAS\"
@@ -896,4 +917,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -921,4 +943,5 @@
     export TEST_NAME="REPRO_8_4"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -960,4 +983,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -1012,4 +1036,5 @@
     export TEST_NAME="REPRO_8_4"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -1074,4 +1099,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=16
@@ -1118,4 +1144,5 @@
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"AGRIF_SHORT\"
@@ -1193,4 +1220,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -1243,4 +1271,5 @@
     export TEST_NAME="REPRO_8_4"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -1297,4 +1326,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -1333,4 +1363,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -1368,4 +1399,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -1394,4 +1426,5 @@
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"S12_SHORT\"
@@ -1431,4 +1464,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
@@ -1457,4 +1491,5 @@
     export TEST_NAME="REPRO_8_4"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32
Index: NEMO/branches/2019/fix_sette_ticket2239/sette_rpt.sh
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/sette_rpt.sh	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/sette_rpt.sh	(revision 10698)
@@ -287,4 +287,10 @@
   pass=$5
 #
+# check if reference directory is present
+  if [ ! -d $vdirref/$nam/$mach/$dorvref ]; then
+    printf "%s\n" " REFERENCE directory $vdirref/$nam/$mach/$dorvref is MISSING"
+    return
+  fi
+#
   if [ -d $vdir/$nam ]; then
     dorv=`ls -1rt $vdir/$nam/$mach/ | tail -1l `
@@ -369,10 +375,10 @@
     f1o=$vdir/$nam/$mach/$dorv/$rep1/ocean.output
     if  [ ! -f $f1o ] ; then
-      if [ $pass == 0 ]; then printf "%-27s %s %s\n" $nam " ocean.output is MISSING            : " $dorv ; fi
+      if [ $pass == 0 ]; then printf "%-27s %s %s %s\n" $nam " ocean.output               MISSING : " $dorv " ( run did not start / finish correctly ) " ; fi
       return;
     else 
       nerr=`grep 'E R R O R' $f1o | wc -l`
       if [[ $nerr > 0 ]]; then
-        printf "%-27s %s %s\n" $nam " run FAILED : " $dorv
+        printf "%-27s %s %s %s\n" $nam " run                         FAILED : " $dorv " ( E R R O R in ocean.output) " 
         if [ $pass == 1 ]; then
           echo "<return> to view end of ocean.output"
@@ -385,5 +391,5 @@
     fi
   else
-    if [ $pass == 0 ]; then printf "%-27s %s %s\n" $nam  " directory is MISSING               : " $dorv ; fi
+    if [ $pass == 0 ]; then printf "%-27s %s %s %s\n" $nam  " directory                  MISSING : " $dorv " ( run did not start / finish correctly ) "; fi
   fi
 }
Index: NEMO/branches/2019/fix_sette_ticket2239/sette_test-cases.sh
===================================================================
--- NEMO/branches/2019/fix_sette_ticket2239/sette_test-cases.sh	(revision 10697)
+++ NEMO/branches/2019/fix_sette_ticket2239/sette_test-cases.sh	(revision 10698)
@@ -60,4 +60,7 @@
 #                      (run.stat and ocean.output) in it after execution of test.
 #
+#  clean_valid_dir    : rename ocean.output/run.stat and tracer.stat to avoid checking them in the report 
+#                       ( not doing it could lead to false positive )
+#
 #  VALIDATION tree is:
 #
@@ -166,4 +169,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=1
@@ -188,4 +192,5 @@
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"OVF_SHORT\"
@@ -226,4 +231,5 @@
         . ./all_functions.sh
         . ./prepare_exe_dir.sh
+        clean_valid_dir
         JOB_FILE=${EXE_DIR}/run_job.sh
         NPROC=1
@@ -257,4 +263,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=1
@@ -279,4 +286,5 @@
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"LOCK_SHORT\"
@@ -317,4 +325,5 @@
         . ./all_functions.sh
         . ./prepare_exe_dir.sh
+        clean_valid_dir
         JOB_FILE=${EXE_DIR}/run_job.sh
         NPROC=1
@@ -349,4 +358,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=6
@@ -380,4 +390,5 @@
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"VORTEX_SHORT\"
@@ -431,4 +442,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=6
@@ -468,4 +480,5 @@
     export TEST_NAME="REPRO_3_2"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=6
@@ -518,4 +531,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=6
@@ -549,4 +563,5 @@
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"ICE_AGRIF_SHORT\"
@@ -609,4 +624,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=6
@@ -646,4 +662,5 @@
     export TEST_NAME="REPRO_3_2"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=6
@@ -695,4 +712,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=15
@@ -719,4 +737,5 @@
     export TEST_NAME="SHORT"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"ISOMIP_SHORT\"
@@ -755,4 +774,5 @@
     . ./all_functions.sh
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=21
@@ -780,4 +800,5 @@
     export TEST_NAME="REPRO_8_4"
     . ./prepare_exe_dir.sh
+    clean_valid_dir
     JOB_FILE=${EXE_DIR}/run_job.sh
     NPROC=32